package it.cnr.iit.obligationengine.obligations;

import java.util.Arrays;
import java.util.Properties;
import java.util.logging.Logger;

import javax.mail.Message;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

import infobip.api.client.SendSingleTextualSms;
import infobip.api.config.ApiKeyAuthConfiguration;
import infobip.api.model.sms.mt.send.textual.SMSTextualRequest;
import it.cnr.iit.common.types.DataManipulationObject;

public class NotifyUserOn {

	private static final Logger log = Logger.getLogger(ObligationEngine.class.getName());

	public void notifyUserOn(DataManipulationObject dmo) {
		if (dmo.getParam().contains("mail")) {
			notifyUserByEmail(dmo);
		} else if (dmo.getParam().contains("sms")) {
			notifyUserBySMS(dmo);
		} else {
			log.severe("unrecognized notifyUserOn params");
		}
	}

	private void notifyUserByEmail(DataManipulationObject dmo) {
		String email = dmo.getOptions();
		String action = dmo.getAdditionalInfo().get("action");
		String dpoId = dmo.getAdditionalInfo().get("dpoId");

		String host = "smtp.gmail.com";

		String port = "587";
		Properties properties = new Properties();
		properties.put("mail.smtp.auth", "true");
		properties.put("mail.smtp.starttls.enable", "true");
		properties.put("mail.smtp.host", host);
		properties.put("mail.smtp.port", port);
		properties.put("mail.smtp.user", ObligationConstants.EMAILSENDER);
		properties.put("mail.debug", "true");
		properties.put("mail.smtp.tls.trust", "smtp.gmail.com");

		Session session = Session.getInstance(properties, new javax.mail.Authenticator() {

			@Override
			protected PasswordAuthentication getPasswordAuthentication() {

				return new PasswordAuthentication(ObligationConstants.EMAILSENDER, ObligationConstants.SENDERPASSWORD);

			}

		});

		try {
			// Create a default MimeMessage object.
			MimeMessage message = new MimeMessage(session);

			// Set From: header field of the header.
			message.setFrom(new InternetAddress(ObligationConstants.EMAILSENDER));

			// Set To: header field of the header.
			message.setRecipient(Message.RecipientType.TO, new InternetAddress(email));

			// Set Subject: header field
			message.setSubject("C3ISP notification");

			// Now set the actual message
			message.setText("This email has been generated by C3ISP system to notify the action " + action
					+ " on the following dpo: " + dpoId);

			Transport.send(message);

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	private static void notifyUserBySMS(DataManipulationObject dmo) {
		String number = dmo.getOptions();
		String action = dmo.getAdditionalInfo().get("action");
		String dpoId = dmo.getAdditionalInfo().get("dpoId");

		SendSingleTextualSms client = new SendSingleTextualSms(
				new ApiKeyAuthConfiguration("0f4ab666c32b9dce46eeeef58504cd4e-ac13a928-74db-4be7-9b3b-062615fb845a"));

		SMSTextualRequest requestBody = new SMSTextualRequest();
		requestBody.setFrom("C3ISP notification");
		requestBody.setTo(Arrays.asList(number));

		String text = "This email has been generated by C3ISP system to notify the action " + action
				+ " on the following dpo: " + dpoId;

		requestBody.setText(text);

//		SMSResponse response = client.execute(requestBody);
//
//		for (SMSResponseDetails sentMessageInfo : response.getMessages()) {
//			System.out.println("Message ID: " + sentMessageInfo.getMessageId());
//			System.out.println("Receiver: " + sentMessageInfo.getTo());
//			System.out.println("Message status: " + sentMessageInfo.getStatus().getName());
//			System.out.println("------------------------------------------------");
//		}
	}

}
